/*
 * Interprocess communication macros.
 *
 * Copyright (C) 2019 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#pragma once

/* Count the size of an array. */

#define VA_ARGCOUNT(TYPE, ARGS) (sizeof(ARGS) / sizeof(TYPE))

/* Prepare an array from a variable argument list. */

#define VA_ARGLIST(TYPE, ...) ((TYPE []) {__VA_ARGS__})

/* Assign array members. */

#define ARRAY_ASSIGN(TO, TYPE, ...) \
  memcpy(TO, VA_ARGLIST(TYPE, __VA_ARGS__), \
             sizeof(VA_ARGLIST(TYPE, __VA_ARGS__)))

#define ipc_set_registers(TO, ...) ARRAY_ASSIGN(TO, l4_umword_t, __VA_ARGS__)
